
#ifndef __nanojit_LirHelper__
#define __nanojit_LirHelper__

#include "stdint.h"


namespace avmplus
{
	inline unsigned int AvmCountBitSet(uint32_t a_iValue)
	{
		unsigned int v = a_iValue; // count bits set in this (32-bit value)
		unsigned int c; // store the total here
		v = v - ((v >> 1) & 0x55555555);                    // reuse input as temporary
		v = (v & 0x33333333) + ((v >> 2) & 0x33333333);     // temp
		c = ((v + ((v >> 4) & 0xF0F0F0F)) * 0x1010101) >> 24; // count

		return c;
	}
}

#if defined(__GNUG__)

namespace avmplus
{

	inline unsigned int AvmCountLeadingZeros(uint32_t a_iValue)
	{
		return a_iValue == 0 ? 32 : __builtin_clz(a_iValue);
	}

}


#else

extern "C" unsigned char _BitScanReverse(unsigned long * Index, unsigned long Mask);
#pragma intrinsic(_BitScanReverse)

namespace avmplus
{

	inline unsigned int AvmCountLeadingZeros(uint32_t a_iValue)
	{
		unsigned long iIndex = 0;
		if (_BitScanReverse(&iIndex, a_iValue))
		{
			return iIndex;
		}

		return 32;
	}
}

#endif


#endif // __nanojit_LirHelper__

