
#ifndef __nanojit_CodeBlockList__
#define __nanojit_CodeBlockList__


namespace nanojit
{
	class CodeBlockList
	{
		/** for making singly linked lists of blocks in any order */
		CodeBlock*		_head;

	public:
		CodeBlockList(CodeBlock* headBlock = NULL) : _head(headBlock) {};

		CodeBlock* head() { return _head; }
		const CodeBlock* head() const { return _head; }

		void clear() { _head = NULL; }

		bool isEmpty() { return _head == NULL; };

		/** append a block to a list. update block list to point to the new head */
		void addBlockToList(CodeBlock* blockToAdd);
		/** remove fist block from list. update block list to point to the new head */
		CodeBlock* removeFirstBlockFromList();
		/** test if a block belongs to the list */
		bool isMember(CodeBlock* block);
		/** find parent of parameter block, return NULL if head */
		CodeBlock* findParent(CodeBlock* block);
		/** remove next block from the linked list */
		static void removeNextBlockFromList(CodeBlock* block);

		/** remove block from list. must iterate over the whole list */
		//bool removeBlockFromList(CodeBlock* blockToRemove);
	};

} // namespace nanojit

#endif // #ifndef __nanojit_CodeBlockList__

